---
title: WeakRef() constructor
slug: Web/JavaScript/Reference/Global_Objects/WeakRef/WeakRef
tags:
  - Constructor
  - JavaScript
  - Reference
  - WeakRef
---
<div>{{JSRef}}</div>

<p>The <strong><code>WeakRef</code></strong> constructor creates a {{jsxref("WeakRef")}} object referring to a given target object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new WeakRef(targetObject);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>targetObject</dt>
 <dd>The target object the WeakRef should refer to (also called the <em>referent</em>).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_new_WeakRef_object">Creating a new WeakRef object</h3>

<p>See the main <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WeakRef#Examples"><code>WeakRef</code></a> page for a complete example.</p>

<pre class="brush: js notranslate">class Counter {
  constructor(element) {
    // Remember a weak reference to a DOM element
    this.ref = new WeakRef(element);
    this.start();
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WeakRefs', '#sec-weak-ref-constructor', 'WeakRef constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.WeakRef.WeakRef")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("WeakRef")}}</li>
</ul>
